#!/bin/sh
# ajouter_images.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: ajouter_images.tcl,v 1.3 2005/03/21 08:38:25 abuledu_andre Exp $
#  Author  : andre.connes@toulouse.iufm.fr
#  Date    : 23/06/2003 Modification : 01/12/2004
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

source mulot.conf
source msg.tcl

  #
  # langue par dfaut
  #
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]

########## Construction de l'interface###########
#frame wa pour ajouter une image
wm geometry . +0+0
wm title . [mc {ajouter_images}]

set dir_origine [pwd]

frame .wa -background #aaaaaa -height 420 -width 400
grid .wa -column 0 -row 0

#si abuledu ncessairement l'utilisateur est prof d'aprs mulot.tcl
if { ! [file exists /etc/abuledu] } {
  label .wa.passwd -text [mc {Password}] -bg red
  place .wa.passwd -x 50 -y 10
  entry .wa.password -show "*"
  place .wa.password -x 150 -y 10
  .wa.password delete 0 end
}

label .wa.lab_selectionner -background #aaaaaa -text [mc {selectionner}]
place .wa.lab_selectionner -x 85 -y 50

  #
  # rpertoires images
  #
  set dir_in  $glob(home) ;# source chez l'utilisateur par defaut
  set dir_out [pwd] ;# but inconnu par dfaut mais...

  set tdir "/usr/share/abuledu/applications/abuledu-mulot/images"
  if { [file exists $tdir] } { 
    set dir_out $tdir ;# mandrake et/ou abuledu-mdk
  } else {
    set tdir "/usr/share/abuledu-mulot/images"
    if { [file exists $tdir] } {
      set dir_out $tdir ;# debian et/ou abuledu-debian
    } else {
      set tdir $dir_out/images
      if { [file exists $tdir] } {
        set dir_out $tdir ; # autre
      }
    }
  }

button .wa.but_dossier_in -text [mc {dossier_in}] ;# message initial
place .wa.but_dossier_in -x 10 -y 90
bind .wa.but_dossier_in <ButtonRelease-1> changeDossier_in

listbox .wa.listin \
	-background #c0c0c0 -height 13 -width 20 \
	-listvariable listeImages \
	-selectmode extended \
	-yscrollcommand ".wa.scrollin set"
scrollbar .wa.scrollin -command ".wa.listin yview"
place .wa.listin -x 10 -y 120
place .wa.scrollin -x 157 -y 120 -height 227

bind .wa.listin <Double-ButtonRelease-1> "capturenomin"

button .wa.but_dossier_out -text [mc {dossier_out}] ;# message intial
place .wa.but_dossier_out -x 185 -y 90
bind .wa.but_dossier_out <ButtonRelease-1> changeDossier_out

listbox .wa.listout \
	-background #c0c0c0 -height 13 -width 20 \
	-listvariable listeImages_out \
	-selectmode single \
	-yscrollcommand ".wa.scrollout set"
scrollbar .wa.scrollout -command ".wa.listout yview"
place .wa.listout -x 185 -y 120
place .wa.scrollout -x 332 -y 120 -height 227

bind .wa.listout <Double-ButtonRelease-1> "capturenomout"

button .wa.faire -text [mc {Faire} ] -command "ajouter_image"
place .wa.faire -x 130 -y 365
button .wa.abandonner -text [mc {Quitter} ] \
	-command "cd \"$dir_origine\" ; exit"
place .wa.abandonner -x 185 -y 365

#
proc changeDossier_in {} {
#
  global dir_in
  set tmp_dir_in $dir_in
  cd $dir_in
  if {[catch { tk_chooseDirectory -initialdir $tmp_dir_in]} r ]} {
    set dir_in $tmp_dir_in
  } else { 
    if { [string length $r] > 0 } {
      set dir_in $r
    } else {
      set dir_in $tmp_dir_in
    }
  }
  set but_text_in [file tail $dir_in]
  .wa.but_dossier_in configure -text $but_text_in
  cd $dir_in
  do_list_in
} ;# changeDossier_in

#
proc changeDossier_out {} {
#
  global dir_out
  set tmp_dir_out $dir_out
  set tmp_dir [pwd]
  cd $dir_out
  if {[catch { tk_chooseDirectory -initialdir $tmp_dir_out]} r ]} {
    set dir_out $tmp_dir_out
  } else { 
    if { [string length $r] > 0 } {
      set dir_out $r
    } else {
      set dir_out $tmp_dir_out
    }
  }
  cd $dir_out
  set but_text_out [file tail $dir_out]
  .wa.but_dossier_out configure -text $but_text_out
  do_list_out
  cd $tmp_dir
} ;# changeDossier_out

#
proc do_list_in { } {
#
  global dir_in
  .wa.listin delete 0 end
  catch {foreach i [lsort [glob -nocomplain $dir_in/* ]] {
          .wa.listin insert end [file tail $i]
        }
  }
}
do_list_in

#
proc do_list_out { } {
#
  global dir_out
  .wa.listout delete 0 end
  catch {foreach i [lsort [glob -nocomplain $dir_out/* ]] {
          .wa.listout insert end [file tail $i]
        }
  }
}
do_list_out

#
proc capturenomin { } {
#
    global dir_in
    set tmp "$dir_in/[.wa.listin get active]"
    if [file isdirectory $tmp] {
      set dir_in $tmp
      cd $dir_in
      .wa.but_dossier_in configure -text [file tail $tmp]
      do_list_in
    }
}

#
proc capturenomout { } {
#
    global dir_out
    set tmp "$dir_out/[.wa.listout get active]"
    if [file isdirectory $tmp] {
      set dir_out $tmp
      cd $dir_out
      .wa.but_dossier_out configure -text [file tail $tmp]
      do_list_out
    }
}

proc ajouter_image {} {
  global glob dir_in dir_out listeImages

  # astuce : si abuledu le mot de passe est auto mais
  #          droits d'ajout pour les profs only
  if {[file exists /etc/abuledu]} {
    set pass $glob(passwd)
  } else {
    set pass [.wa.password get]
  }
  if {$pass == $glob(passwd)} {
    set lselection [.wa.listin curselection]
    foreach i $lselection {
      set img [lindex $listeImages $i]
      catch { file copy $dir_in/$img $dir_out }
      if { $glob(platform) == "unix" } {
        catch {exec mogrify -geometry 600x400 $dir_out/$img }
      }
    }
  }
  do_list_out
} ;# ajouter_image

