#!/bin/sh
# effacer_images.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: effacer_images.tcl,v 1.3 2005/03/21 08:38:25 abuledu_andre Exp $
#  Author  : andre.connes@toulouse.iufm.fr
#  Date    : 23/06/2003 Modification : 01/12/2004
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

source mulot.conf
source msg.tcl

  #
  # langue par dfaut
  #
  set f [open [file join $glob(home_reglages) lang.conf] "r"]
  gets $f lang
  close $f
  ::msgcat::mclocale $lang
  ::msgcat::mcload [file join [file dirname [info script]] msgs]

########## Construction de l'interface###########
#frame we pour effacer des images
wm geometry . +0+0
wm title . [mc {effacer_images}]

frame .we -background #aaaaaa -height 420 -width 400
grid .we -column 0 -row 0


#si abuledu ncessairement l'utilisateur est prof d'aprs mulot.tcl
if { ! [file exists /etc/abuledu] } {
  label .we.passwd -text [mc {Password}] -bg red
  place .we.passwd -x 50 -y 10
  entry .we.password -show "*"
  place .we.password -x 150 -y 10
  .we.password delete 0 end
}

  #
  # rpertoire images
  #
  set dir_out [pwd] ;# rpertoire inconnu par dfaut
  set tdir "/usr/share/abuledu/applications/abuledu-mulot/images"
  if { [file exists $tdir] } { 
    set dir_out $tdir ;# mandrake et/ou abuledu-mdk
  } else {
    set tdir "/usr/share/abuledu-mulot/images"
    if { [file exists $tdir] } {
      set dir_out $tdir ;# debian et/ou abuledu-debian
    } else {
      set tdir $dir_out/images
      if { [file exists $tdir] } {
        set dir_out $tdir ; # autre
      }
    }
  }

set but_text_out [mc {dossier_out}]
button .we.but_dossier_out -text $but_text_out
place .we.but_dossier_out -x 110 -y 45
bind .we.but_dossier_out <ButtonRelease-1> changeDossier_out

cd $dir_out
listbox .we.listout \
	-background #c0c0c0 -height 13 -width 20 \
	-listvariable listeImages \
	-selectmode extended \
	-yscrollcommand ".we.scrollout set"
scrollbar .we.scrollout -command ".we.listout yview"
place .we.listout -x 110 -y 80
place .we.scrollout -x 257 -y 80 -height 227

bind .we.listout <Double-ButtonRelease-1> "capturenomout"

button .we.faire -text [mc {Faire} ] -command "effacer_image"
place .we.faire -x 130 -y 325
button .we.abandonner -text [mc {Quitter} ] \
	-command exit
place .we.abandonner -x 185 -y 325

#
proc changeDossier_out {} {
#
  global dir_out
  set tmp_dir_out $dir_out
  set tmp_dir [pwd]
  cd $dir_out
  if {[catch { tk_chooseDirectory -initialdir $tmp_dir_out]} r ]} {
    set dir_out $tmp_dir_out
  } else { 
    if { [string length $r] > 0 } {
      set dir_out $r
    } else {
      set dir_out $tmp_dir_out
    }
  }
  cd $dir_out
  set but_text_out [file tail $dir_out]
  .we.but_dossier_out configure -text $but_text_out
  cd $dir_out
  do_list_out
  cd $tmp_dir
} ;# changeDossier_out

#
proc do_list_out { } {
#
  global dir_out
  .we.listout delete 0 end
  catch {foreach i [lsort [glob -nocomplain $dir_out/* ]] {
          .we.listout insert end [file tail $i]
        }
  }
}
do_list_out

#
proc capturenomout { } {
#
    global dir_out
    set tmp "$dir_out/[.we.listout get active]"
    if [file isdirectory $tmp] {
      set dir_out $tmp
      cd $dir_out
      .we.but_dossier_out configure -text [file tail $tmp]
      do_list_out
    }
}

proc effacer_image {} {
  global glob dir_out listeImages

  # astuce : si abuledu le mot de passe est auto mais
  #          droits d'ajout pour les profs only
  if {[file exists /etc/abuledu]} {
    set pass $glob(passwd)
  } else {
    set pass [.we.password get]
  }
  if {$pass == $glob(passwd)} {
    set lselection [.we.listout curselection]
    foreach i $lselection {
      set img [lindex $listeImages $i]
      catch { file delete $dir_out/$img }
    }
  }
  do_list_out
} ;# effacer_image
