#!/bin/sh
#effacer_mulot.tcl
# \
exec wish "$0" ${1+"$@"}

#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
# 
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
# 
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
# 
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
# 
#**************************************************************************
#  File  : $Id: effacer_mulot.tcl,v 1.2 2004/05/06 09:39:00 abuledu_andre Exp $
#  Author  : andre.connes@toulouse.iufm.fr
#  Date    : 23/06/2003 Modification : 01/05/2004
#  Licence : GNU/GPL Version 2 ou plus
# 
#  Description:
#  ------------
# 
#  @version    
#  @author     Andre Connes
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
# 
#  *************************************************************************

source mulot.conf
source msg.tcl

# Dcommenter la ligne suivante si Img est installe
# package require Img

########## Construction de l'interface###########
#frame we pour lister les images
wm geometry . +0+0
wm title . [mc {Effacer}]

frame .we -background #aaaaaa -height 420 -width 320
grid .we -column 0 -row 0

label .we.passwd -text [mc {Password}] -bg red
place .we.passwd -x 100 -y 10
entry .we.password -show "*"
place .we.password -x 100 -y 30
.we.password delete 0 end

listbox .we.liste -background #c0c0c0 -height 10 -width 20 -yscrollcommand ".we.scroll set"
scrollbar .we.scroll -command ".we.liste yview"
place .we.liste -x 100 -y 70
place .we.scroll -x 227 -y 70 -height 172
label .we.menu3 -text [mc {Double clic pour choisir une image}] -background #aaaaaa
place .we.menu3 -x 80 -y 50
entry .we.text
place .we.text -x 100 -y 280
.we.text delete 0 end

button .we.supprimer -text [mc {Faire} ] -command "supprimer_image"
place .we.supprimer -x 95 -y 305
button .we.abandonner -text [mc {Quitter} ] -command exit
place .we.abandonner -x 185 -y 305

bind .we.liste <Double-ButtonRelease-1> "capturenom"

# lister les images
proc peupleliste {} {
        .we.liste delete 0 end
        catch {foreach i [lsort [glob [file join images/*]]] {
                .we.liste insert end [file tail $i]
            }
        }
    }
peupleliste 


proc capturenom {} {
    .we.text delete 0 end
    .we.text insert 0 [.we.liste get active]
}

proc supprimer_image {} {
  global glob
  # astuce : si abuledu le mot de passe est auto mais
  #          droits d'effacement pour les profs only
  if {[file exists /etc/abuledu]} {
    set pass $glob(passwd)
  } else {
    set pass [.we.password get]
  }
  if {$pass == $glob(passwd)} {
    catch {file delete images/[.we.text get]}
    peupleliste
  }
  .we.text delete 0 end
}
